﻿#target "InDesign"

function getLinesInFrame(text, column) {
	var arr = [];
	for (var i=0; i < text.lines.length; i++) {
		if (text.lines[i].textColumns[0]== column) {
			arr.push(text.lines[i]);
		}
	}
	var start = arr[0].baseline-arr[0].ascent;
	var end = arr[arr.length-1].baseline+arr[arr.length-1].descent;
	return end-start;
}

function getColumnWidth(column) {
	var tf = column.parentTextFrames[0];
	var tfWidth = tf.geometricBounds[3]-tf.geometricBounds[1];
	var pref = tf.textFramePreferences;
	if (pref.useFixedColumnWidth) {
		return pref.textColumnFixedWidth;
	} else {
		return (tfWidth - pref.textColumnGutter*(pref.textColumnCount-1))/pref.textColumnCount;
	}
}

function getArea (text) {
	var result = 0;
	for (var i=0; i < text.textColumns.length; i++) {
		var column = text.textColumns[i];
		var width = getColumnWidth(column);
		var height = getLinesInFrame(text, column);
		result += width*height/100;
	}
	return result;
}

with (app) {
	try {
		var doc = activeDocument;
	} catch (error) {
		alert('No documents are open!');
		exit();
	}
	try {
		var text = selection[0];
		var chk = text.characters.length;
	} catch (error) {
		alert('No text are selected!');
		exit();
	}
	var area = getArea(text);
	var dialog = 'dialog{size:[256, 100], margins:8, justify:"fill", label:StaticText{justify:"center"}}';
	var wnd = new Window (dialog);
	data = wnd.add("edittext", [0, 0, 240, 50], "", {multiline: true});
	wnd.label.graphics.font = ScriptUI.newFont("Helvetica", "Bold", 9);
	wnd.label.text = 'Count result: (Esc for exit:)';
	data.graphics.font = ScriptUI.newFont("Arial", "Regular", 9);
	data.text = '\"' + text.contents.slice(0,100) + '…\": ' + Math.round(area) + ' см2';
	wnd.layout.layout();
	wnd.show();
}